diff --git a/drivers/video/sunxi/lcd_fb/panels/kld39501.c b/drivers/video/sunxi/lcd_fb/panels/kld39501.c
index e01e8c74f..be03b695a 100644
--- a/drivers/video/sunxi/lcd_fb/panels/kld39501.c
+++ b/drivers/video/sunxi/lcd_fb/panels/kld39501.c
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
@@ -54,10 +54,6 @@ static void LCD_panel_init(u32 sel);
 static void LCD_panel_exit(u32 sel);
 #define RESET(s, v) sunxi_lcd_gpio_set_value(s, 0, v)
 
-
-static struct disp_panel_para info[LCD_FB_MAX];
-
-
 static void address(unsigned int sel, int x, int y, int width, int height)
 {
 	sunxi_lcd_cmd_write(sel, 0x2B); /* Set row address */
@@ -72,18 +68,17 @@ static void address(unsigned int sel, int x, int y, int width, int height)
 	sunxi_lcd_para_write(sel, width & 0xff);
 }
 
-
 void LCD_panel_init(unsigned int sel)
 {
 	unsigned int rotate;
+	struct sunxi_lcd_fb_disp_panel_para info;
+	memset(&info, 0, sizeof(info));
 
-
-	if (bsp_disp_get_panel_info(sel, &info[sel])) {
-		lcd_fb_wrn("get panel info fail!\n");
+	if (sunxi_lcd_fb_bsp_disp_get_panel_info(sel, &info)) {
+		LCDFB_WRN("get panel info fail!\n");
 		return;
 	}
 
-
 	sunxi_lcd_cmd_write(sel, 0xf0); /* sunxi_lcd_cmd_write Set Control */
 	sunxi_lcd_para_write(sel, 0xc3);
 	sunxi_lcd_cmd_write(sel, 0xf0); /* */
@@ -93,10 +88,11 @@ void LCD_panel_init(unsigned int sel)
 	sunxi_lcd_para_write(sel, 0x00);
 	sunxi_lcd_para_write(sel, 0x00);
 
-	sunxi_lcd_cmd_write(sel, 0x36); /* Memory sunxi_lcd_para_write Access Control */
+	sunxi_lcd_cmd_write(
+		sel, 0x36); /* Memory sunxi_lcd_para_write Access Control */
 
 	/* MY MX MV ML RGB MH 0 0 */
-	if (info[sel].lcd_x > info[sel].lcd_y)
+	if (info.lcd_x > info.lcd_y)
 		rotate = 0x20;
 	else
 		rotate = 0x40;
@@ -117,28 +113,33 @@ void LCD_panel_init(unsigned int sel)
 
 	sunxi_lcd_cmd_write(sel, 0x3A); /* Interface Pixel Format */
 	/* 55----RGB565;66---RGB666 */
-	if (info[sel].lcd_pixel_fmt == LCDFB_FORMAT_RGB_565 ||
-	    info[sel].lcd_pixel_fmt == LCDFB_FORMAT_BGR_565) {
+	if (info.lcd_pixel_fmt == LCDFB_FORMAT_RGB_565 ||
+	    info.lcd_pixel_fmt == LCDFB_FORMAT_BGR_565) {
 		sunxi_lcd_para_write(sel, 0x55);
-		sunxi_lcd_cmd_write(sel, 0x36); /* Memory sunxi_lcd_para_write Access Control */
-		if (info[sel].lcd_pixel_fmt == LCDFB_FORMAT_RGB_565)
+		sunxi_lcd_cmd_write(
+			sel,
+			0x36); /* Memory sunxi_lcd_para_write Access Control */
+		if (info.lcd_pixel_fmt == LCDFB_FORMAT_RGB_565)
 			sunxi_lcd_para_write(sel, rotate | 0x08);
 		else
 			sunxi_lcd_para_write(sel, rotate & 0xf7);
-	} else if (info[sel].lcd_pixel_fmt == LCDFB_FORMAT_ARGB_8888) {
+	} else if (info.lcd_pixel_fmt == LCDFB_FORMAT_ARGB_8888) {
 		sunxi_lcd_para_write(sel, 0x77);
-		sunxi_lcd_cmd_write(sel, 0x36); /* Memory sunxi_lcd_para_write Access Control */
+		sunxi_lcd_cmd_write(
+			sel,
+			0x36); /* Memory sunxi_lcd_para_write Access Control */
 		sunxi_lcd_para_write(sel, rotate | 0x08);
 	} else
 		sunxi_lcd_para_write(sel, 0x66);
 
 	sunxi_lcd_cmd_write(sel, 0xB4); /* Display Inversion Control */
-	sunxi_lcd_para_write(sel, 0x01);  /* 1-dot */
+	sunxi_lcd_para_write(sel, 0x01); /* 1-dot */
 
 	sunxi_lcd_cmd_write(sel, 0xB7); /* Entry Mode Set */
-	sunxi_lcd_para_write(sel, 0x46);  /* c6 */
+	sunxi_lcd_para_write(sel, 0x46); /* c6 */
 
-	sunxi_lcd_cmd_write(sel, 0xe6); /* Fixed SPI 50MHz and 60MHz LCD display problems */
+	sunxi_lcd_cmd_write(
+		sel, 0xe6); /* Fixed SPI 50MHz and 60MHz LCD display problems */
 	sunxi_lcd_para_write(sel, 0xff);
 	sunxi_lcd_para_write(sel, 0xc2);
 
@@ -193,16 +194,14 @@ void LCD_panel_init(unsigned int sel)
 	sunxi_lcd_para_write(sel, 0x20);
 	sunxi_lcd_para_write(sel, 0x23);
 
-
-	if (info[sel].lcd_if == LCD_FB_IF_DBI &&
-	    info[sel].dbi_if == LCD_FB_D2LI) {
+	if (info.lcd_if == LCD_FB_IF_DBI && info.dbi_if == LCD_FB_D2LI) {
 		/* two data lane */
 		sunxi_lcd_cmd_write(sel, 0xB9);
 		sunxi_lcd_para_write(sel, 0x00);
 		sunxi_lcd_para_write(sel, 0x01);
 	}
 
-	address(sel, 0, 0, info[sel].lcd_x - 1, info[sel].lcd_y - 1);
+	address(sel, 0, 0, info.lcd_x - 1, info.lcd_y - 1);
 	sunxi_lcd_cmd_write(sel, 0xf0);
 	sunxi_lcd_para_write(sel, 0x3c);
 	sunxi_lcd_cmd_write(sel, 0xf0);
@@ -212,7 +211,6 @@ void LCD_panel_init(unsigned int sel)
 	sunxi_lcd_delay_ms(120);
 	sunxi_lcd_cmd_write(sel, 0x29); /* Display ON */
 	sunxi_lcd_cmd_write(sel, 0x2c); /* Display ON */
-
 }
 
 void LCD_panel_exit(unsigned int sel)
@@ -226,7 +224,6 @@ void LCD_panel_exit(unsigned int sel)
 	sunxi_lcd_delay_ms(10);
 
 	sunxi_lcd_pin_cfg(sel, 0);
-
 }
 
 int lcd_blank(unsigned int sel, unsigned int en)
@@ -238,16 +235,15 @@ int lcd_blank(unsigned int sel, unsigned int en)
 	return 0;
 }
 
-
 static s32 LCD_open_flow(u32 sel)
 {
-	lcd_fb_here;
+	LCDFB_HERE;
 	/* open lcd power, and delay 50ms */
 	LCD_OPEN_FUNC(sel, LCD_power_on, 50);
 	/* open lcd power, than delay 200ms */
 	LCD_OPEN_FUNC(sel, LCD_panel_init, 50);
 	/* open lcd power, than delay 200ms */
-	LCD_OPEN_FUNC(sel, lcd_fb_black_screen, 20);
+	LCD_OPEN_FUNC(sel, sunxi_lcd_fb_black_screen, 20);
 	/* open lcd backlight, and delay 0ms */
 	LCD_OPEN_FUNC(sel, LCD_bl_open, 0);
 
@@ -256,7 +252,7 @@ static s32 LCD_open_flow(u32 sel)
 
 static s32 LCD_close_flow(u32 sel)
 {
-	lcd_fb_here;
+	LCDFB_HERE;
 	/* close lcd backlight, and delay 0ms */
 	LCD_CLOSE_FUNC(sel, LCD_bl_close, 50);
 	/* open lcd power, than delay 200ms */
@@ -270,9 +266,9 @@ static s32 LCD_close_flow(u32 sel)
 static void LCD_power_on(u32 sel)
 {
 	/* config lcd_power pin to open lcd power0 */
-	lcd_fb_here;
+	LCDFB_HERE;
 	sunxi_lcd_power_enable(sel, 0);
-	lcd_fb_here;
+	LCDFB_HERE;
 
 	sunxi_lcd_pin_cfg(sel, 1);
 	RESET(sel, 1);
@@ -284,7 +280,7 @@ static void LCD_power_on(u32 sel)
 
 static void LCD_power_off(u32 sel)
 {
-	lcd_fb_here;
+	LCDFB_HERE;
 	/* config lcd_power pin to close lcd power0 */
 	sunxi_lcd_power_disable(sel, 0);
 }
@@ -294,7 +290,7 @@ static void LCD_bl_open(u32 sel)
 	sunxi_lcd_pwm_enable(sel);
 	/* config lcd_bl_en pin to open lcd backlight */
 	sunxi_lcd_backlight_enable(sel);
-	lcd_fb_here;
+	LCDFB_HERE;
 }
 
 static void LCD_bl_close(u32 sel)
@@ -302,16 +298,16 @@ static void LCD_bl_close(u32 sel)
 	/* config lcd_bl_en pin to close lcd backlight */
 	sunxi_lcd_backlight_disable(sel);
 	sunxi_lcd_pwm_disable(sel);
-	lcd_fb_here;
+	LCDFB_HERE;
 }
 
-
 static int lcd_set_var(unsigned int sel, struct fb_info *p_info)
 {
 	return 0;
 }
 
-static int lcd_set_addr_win(unsigned int sel, int x, int y, int width, int height)
+static int lcd_set_addr_win(unsigned int sel, int x, int y, int width,
+			    int height)
 {
 	address(sel, x, y, width, height);
 	return 0;
@@ -326,5 +322,5 @@ struct __lcd_panel kld39501_panel = {
 		.blank = lcd_blank,
 		.set_var = lcd_set_var,
 		.set_addr_win = lcd_set_addr_win,
-		},
+	},
 };
diff --git a/drivers/video/sunxi/lcd_fb/panels/kld39501.h b/drivers/video/sunxi/lcd_fb/panels/kld39501.h
index df1d4feca..566b81b1c 100644
--- a/drivers/video/sunxi/lcd_fb/panels/kld39501.h
+++ b/drivers/video/sunxi/lcd_fb/panels/kld39501.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
diff --git a/drivers/video/sunxi/lcd_fb/panels/lcd_source.h b/drivers/video/sunxi/lcd_fb/panels/lcd_source.h
index b5e6d91e5..9c4995689 100644
--- a/drivers/video/sunxi/lcd_fb/panels/lcd_source.h
+++ b/drivers/video/sunxi/lcd_fb/panels/lcd_source.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Allwinner SoCs display driver.
@@ -9,115 +9,286 @@
  * License version 2.  This program is licensed "as is" without any
  * warranty of any kind, whether express or implied.
  */
+#ifndef _LCD_SOURCE_H_
+#define _LCD_SOURCE_H_
 
 #include "panels.h"
 
-extern struct sunxi_lcd_drv g_lcd_drv;
+struct sunxi_lcd_drv {
+	struct sunxi_lcd_fb_disp_source_ops src_ops;
+};
+
+extern struct sunxi_lcd_drv g_lcd_fb_drv;
 
 /**
  * sunxi_lcd_delay_ms.
  * @ms: Delay time, unit: millisecond.
  */
-s32 sunxi_lcd_delay_ms(u32 ms);
+static inline s32 sunxi_lcd_panel_delay_ms(u32 ms)
+{
+	return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_delay_ms_ops(ms);
+
+	return -1;
+}
 
 /**
- * sunxi_lcd_delay_us.
- * @us: Delay time, unit: microsecond.
- */
-s32 sunxi_lcd_delay_us(u32 us);
+  * sunxi_lcd_delay_us.
+  * @us: Delay time, unit: microsecond.
+  */
+static inline s32 sunxi_lcd_panel_delay_us(u32 us)
+{
+	return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_delay_us_ops(us);
 
+	return -1;
+}
 
 /**
- * sunxi_lcd_backlight_enable - enable the backlight of panel.
- * @screen_id: The index of screen.
- */
-void sunxi_lcd_backlight_enable(u32 screen_id);
+  * sunxi_lcd_backlight_enable - enable the backlight of panel.
+  * @screen_id: The index of screen.
+  */
+static inline void sunxi_lcd_panel_backlight_enable(u32 screen_id)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_backlight_enable_ops)
+		g_lcd_fb_drv.src_ops.sunxi_lcd_fb_backlight_enable_ops(
+			screen_id);
+}
 
 /**
- * sunxi_lcd_backlight_disable - disable the backlight of panel.
- * @screen_id: The index of screen.
- */
-void sunxi_lcd_backlight_disable(u32 screen_id);
+  * sunxi_lcd_backlight_disable - disable the backlight of panel.
+  * @screen_id: The index of screen.
+  */
+static inline void sunxi_lcd_panel_backlight_disable(u32 screen_id)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_backlight_disable_ops)
+		g_lcd_fb_drv.src_ops.sunxi_lcd_fb_backlight_disable_ops(
+			screen_id);
+}
 
 /**
- * sunxi_lcd_power_enable - enable the power of panel.
- * @screen_id: The index of screen.
- * @pwr_id:     The index of power
- */
-void sunxi_lcd_power_enable(u32 screen_id, u32 pwr_id);
+  * sunxi_lcd_power_enable - enable the power of panel.
+  * @screen_id: The index of screen.
+  * @pwr_id:     The index of power
+  */
+static inline void sunxi_lcd_panel_power_enable(u32 screen_id, u32 pwr_id)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_power_enable_ops)
+		g_lcd_fb_drv.src_ops.sunxi_lcd_fb_power_enable_ops(screen_id,
+								   pwr_id);
+}
 
 /**
- * sunxi_lcd_power_disable - disable the power of panel.
- * @screen_id: The index of screen.
- * @pwr_id:     The index of power
- */
-void sunxi_lcd_power_disable(u32 screen_id, u32 pwr_id);
+  * sunxi_lcd_power_disable - disable the power of panel.
+  * @screen_id: The index of screen.
+  * @pwr_id:     The index of power
+  */
+static inline void sunxi_lcd_panel_power_disable(u32 screen_id, u32 pwr_id)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_power_disable_ops)
+		g_lcd_fb_drv.src_ops.sunxi_lcd_fb_power_disable_ops(screen_id,
+								    pwr_id);
+}
 
 /**
- * sunxi_pwm_enable - enable pwm modules, start output pwm wave.
- * @pwm_channel: The index of pwm channel.
- *
- * need to conifg gpio for pwm function
- */
-s32 sunxi_lcd_pwm_enable(u32 pwm_channel);
+  * sunxi_lcd_pwm_enable - enable pwm modules, start output pwm wave.
+  * @screen_id: The index of screen.
+  *
+  * need to conifg gpio for pwm function
+  */
+static inline s32 sunxi_lcd_panel_pwm_enable(u32 screen_id)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_pwm_enable_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_pwm_enable_ops(
+			screen_id);
 
-/**
- * sunxi_pwm_disable - disable pwm modules, stop output pwm wave.
- * @pwm_channel: The index of pwm channel.
- */
-s32 sunxi_lcd_pwm_disable(u32 pwm_channel);
+	return -1;
+}
 
+/**
+  * sunxi_lcd_pwm_disable - disable pwm modules, stop output pwm wave.
+  * @screen_id: The index of screen.
+  */
+static inline s32 sunxi_lcd_panel_pwm_disable(u32 screen_id)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_pwm_disable_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_pwm_disable_ops(
+			screen_id);
 
+	return -1;
+}
 
 /**
- * sunxi_lcd_pin_cfg - config pin panel used
- * @screen_id: The index of screen.
- * @bon:     1: config pin according to sys_config, 0: set disable state
- */
-s32 sunxi_lcd_pin_cfg(u32 screen_id, u32 bon);
+  * sunxi_lcd_set_panel_funs -  set panel functions.
+  * @name: The panel driver name.
+  * @lcd_cfg: The functions.
+  */
+static inline s32
+sunxi_lcd_panel_set_panel_funs(char *name,
+			       struct sunxi_lcd_fb_disp_lcd_panel_fun *lcd_cfg)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_set_panel_funs_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_set_panel_funs_ops(
+			name, lcd_cfg);
+
+	return -1;
+}
 
 /**
- * sunxi_lcd_set_panel_funs -  set panel functions.
- * @name: The panel driver name.
- * @lcd_cfg: The functions.
- */
-s32 sunxi_lcd_set_panel_funs(char *name, struct disp_lcd_panel_fun *lcd_cfg);
+  * sunxi_lcd_pin_cfg - config pin panel used
+  * @screen_id: The index of screen.
+  * @bon:     1: config pin according to sys_config, 0: set disable state
+  */
+static inline s32 sunxi_lcd_panel_pin_cfg(u32 screen_id, u32 bon)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_pin_cfg_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_pin_cfg_ops(screen_id,
+								     bon);
+
+	return -1;
+}
 
 /**
- * sunxi_lcd_gpio_set_value
- * @screen_id: The index of screen.
- * @io_index:  the index of gpio
- * @value: value of gpio to be set
- */
-s32 sunxi_lcd_gpio_set_value(u32 screen_id, u32 io_index, u32 value);
+  * sunxi_lcd_gpio_set_value
+  * @screen_id: The index of screen.
+  * @io_index:  the index of gpio
+  * @value: value of gpio to be set
+  */
+static inline s32 sunxi_lcd_panel_gpio_set_value(u32 screen_id, u32 io_index,
+						 u32 value)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_gpio_set_value_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_gpio_set_value_ops(
+			screen_id, io_index, value);
+
+	return -1;
+}
 
 /**
- * sunxi_lcd_gpio_set_direction
- * @screen_id: The index of screen.
- * @io_index:  the index of gpio
- * @direction: value of gpio to be set
- */
-s32 sunxi_lcd_gpio_set_direction(u32 screen_id, u32 io_index, u32 direction);
+  * sunxi_lcd_gpio_set_direction
+  * @screen_id: The index of screen.
+  * @io_index:  the index of gpio
+  * @direct: value of gpio to be set
+  */
+static inline s32 sunxi_lcd_panel_gpio_set_direction(u32 screen_id,
+						     u32 io_index, u32 direct)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_gpio_set_direction_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_gpio_set_direction_ops(
+			screen_id, io_index, direct);
+
+	return -1;
+}
 
 /**
- * sunxi_lcd_cmd_write
- * @screen_id: The index of screen.
- * @cmd:  command to be send
- */
-s32 sunxi_lcd_cmd_write(u32 screen_id, u8 cmd);
+  * sunxi_lcd_cmd_write
+  * @screen_id: The index of screen.
+  * @cmd:  command to be send
+  */
+static inline s32 sunxi_lcd_panel_cmd_write(u32 screen_id, u8 cmd)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_cmd_write_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_cmd_write_ops(
+			screen_id, cmd);
+
+	return -1;
+}
 
 /**
- * sunxi_lcd_para_write
- * @screen_id: The index of screen.
- * @cmd:  command to be send
- */
-s32 sunxi_lcd_para_write(u32 screen_id, u8 para);
+  * sunxi_lcd_para_write
+  * @screen_id: The index of screen.
+  * @para:  para to be writed
+  */
+static inline s32 sunxi_lcd_panel_para_write(u32 screen_id, u8 para)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_para_write_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_para_write_ops(
+			screen_id, para);
+
+	return -1;
+}
 
 /**
- * sunxi_lcd_para_write
- * @screen_id: The index of screen.
- * @cmd:  command to be send
- */
-s32 sunxi_lcd_cmd_read(u32 screen_id, u8 cmd, u8 *rx_buf, u8 len);
+  * sunxi_lcd_para_write
+  * @screen_id: The index of screen.
+  * @cmd:  command to be read
+  * @len:  length of bytes to be read
+  */
+static inline s32 sunxi_lcd_panel_cmd_read(u32 screen_id, u8 cmd, u8 *rx_buf,
+					   u8 len)
+{
+	if (g_lcd_fb_drv.src_ops.sunxi_lcd_fb_cmd_read_ops)
+		return g_lcd_fb_drv.src_ops.sunxi_lcd_fb_cmd_read_ops(
+			screen_id, cmd, rx_buf, len);
+
+	return -1;
+}
+
+/* For back port to old Panel Driver */
+#ifndef sunxi_lcd_delay_ms
+#define sunxi_lcd_delay_ms sunxi_lcd_panel_delay_ms
+#endif
+
+#ifndef sunxi_lcd_delay_us
+#define sunxi_lcd_delay_us sunxi_lcd_panel_delay_us
+#endif
+
+#ifndef sunxi_lcd_backlight_enable
+#define sunxi_lcd_backlight_enable sunxi_lcd_panel_backlight_enable
+#endif
+
+#ifndef sunxi_lcd_backlight_disable
+#define sunxi_lcd_backlight_disable sunxi_lcd_panel_backlight_disable
+#endif
+
+#ifndef sunxi_lcd_power_enable
+#define sunxi_lcd_power_enable sunxi_lcd_panel_power_enable
+#endif
+
+#ifndef sunxi_lcd_power_disable
+#define sunxi_lcd_power_disable sunxi_lcd_panel_power_disable
+#endif
+
+#ifndef sunxi_lcd_pwm_enable
+#define sunxi_lcd_pwm_enable sunxi_lcd_panel_pwm_enable
+#endif
+
+#ifndef sunxi_lcd_pwm_disable
+#define sunxi_lcd_pwm_disable sunxi_lcd_panel_pwm_disable
+#endif
+
+#ifndef sunxi_lcd_set_panel_funs
+#define sunxi_lcd_set_panel_funs sunxi_lcd_panel_set_panel_funs
+#endif
+
+#ifndef sunxi_lcd_pin_cfg
+#define sunxi_lcd_pin_cfg sunxi_lcd_panel_pin_cfg
+#endif
+
+#ifndef sunxi_lcd_gpio_set_value
+#define sunxi_lcd_gpio_set_value sunxi_lcd_panel_gpio_set_value
+#endif
+
+#ifndef sunxi_lcd_gpio_set_direction
+#define sunxi_lcd_gpio_set_direction sunxi_lcd_panel_gpio_set_direction
+#endif
+
+#ifndef sunxi_lcd_cmd_write
+#define sunxi_lcd_cmd_write sunxi_lcd_panel_cmd_write
+#endif
+
+#ifndef sunxi_lcd_para_write
+#define sunxi_lcd_para_write sunxi_lcd_panel_para_write
+#endif
+
+#ifndef sunxi_lcd_cmd_read
+#define sunxi_lcd_cmd_read sunxi_lcd_panel_cmd_read
+#endif
+
+#ifndef LCD_OPEN_FUNC
+#define LCD_OPEN_FUNC LCD_FB_OPEN_FUNC
+#endif
+
+#ifndef LCD_CLOSE_FUNC
+#define LCD_CLOSE_FUNC LCD_FB_CLOSE_FUNC
+#endif
 
-extern struct sunxi_lcd_drv g_lcd_drv;
+#endif /* _LCD_SOURCE_H_ */
diff --git a/drivers/video/sunxi/lcd_fb/panels/nv3029s.c b/drivers/video/sunxi/lcd_fb/panels/nv3029s.c
index ba5707ab7..8e77bacea 100644
--- a/drivers/video/sunxi/lcd_fb/panels/nv3029s.c
+++ b/drivers/video/sunxi/lcd_fb/panels/nv3029s.c
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
@@ -58,8 +58,6 @@ static void LCD_panel_exit(u32 sel);
 #define RESET(s, v) sunxi_lcd_gpio_set_value(s, 0, v)
 #define power_en(sel, val) sunxi_lcd_gpio_set_value(sel, 0, val)
 
-static struct disp_panel_para info[LCD_FB_MAX];
-
 static void address(unsigned int sel, int x, int y, int width, int height)
 {
 	sunxi_lcd_cmd_write(sel, 0x2B); /* Set row address */
@@ -77,10 +75,11 @@ static void address(unsigned int sel, int x, int y, int width, int height)
 static void LCD_panel_init(unsigned int sel)
 {
 	unsigned int rotate;
+	struct sunxi_lcd_fb_disp_panel_para info;
+	memset(&info, 0, sizeof(info));
 
-
-	if (bsp_disp_get_panel_info(sel, &info[sel])) {
-		lcd_fb_wrn("get panel info fail!\n");
+	if (sunxi_lcd_fb_bsp_disp_get_panel_info(sel, &info)) {
+		LCDFB_WRN("get panel info fail!\n");
 		return;
 	}
 
@@ -141,13 +140,13 @@ static void LCD_panel_init(unsigned int sel)
 
 	/* NV3029S GAMMA */
 	sunxi_lcd_cmd_write(sel, 0xe0); /* gmama set 2.2 */
-	sunxi_lcd_para_write(sel, 0x10);  /* PKP0[4:0]V3 */
-	sunxi_lcd_para_write(sel, 0x17);  /* PKP1[4:0]V4 */
-	sunxi_lcd_para_write(sel, 0x09);  /* PKP2[4:0]V10 */
-	sunxi_lcd_para_write(sel, 0x1a);  /* PKP3[4:0]V21 */
-	sunxi_lcd_para_write(sel, 0x05);  /* PKP4[4:0]V27 */
-	sunxi_lcd_para_write(sel, 0x0E);  /* PKP5[4:0]V28 */
-	sunxi_lcd_para_write(sel, 0x15);  /* PKP6[4:0]V15 */
+	sunxi_lcd_para_write(sel, 0x10); /* PKP0[4:0]V3 */
+	sunxi_lcd_para_write(sel, 0x17); /* PKP1[4:0]V4 */
+	sunxi_lcd_para_write(sel, 0x09); /* PKP2[4:0]V10 */
+	sunxi_lcd_para_write(sel, 0x1a); /* PKP3[4:0]V21 */
+	sunxi_lcd_para_write(sel, 0x05); /* PKP4[4:0]V27 */
+	sunxi_lcd_para_write(sel, 0x0E); /* PKP5[4:0]V28 */
+	sunxi_lcd_para_write(sel, 0x15); /* PKP6[4:0]V15 */
 	sunxi_lcd_cmd_write(sel, 0xe3);
 	sunxi_lcd_para_write(sel, 0x09); /* PKN0[4:0]V3 */
 	sunxi_lcd_para_write(sel, 0x17); /* PKN1[4:0]V4 */
@@ -190,51 +189,49 @@ static void LCD_panel_init(unsigned int sel)
 	sunxi_lcd_cmd_write(sel, 0x35);
 	sunxi_lcd_para_write(sel, 0x00);
 
-
 	/* MY MX MV ML RGB MH 0 0 */
-	if (info[sel].lcd_x > info[sel].lcd_y)
+	if (info.lcd_x > info.lcd_y)
 		rotate = 0xa0;
 	else
 		rotate = 0xC0;
 
-
 	sunxi_lcd_cmd_write(sel, 0x3A); /* Interface Pixel Format */
 	/* 55----RGB565;66---RGB666 */
-	if (info[sel].lcd_pixel_fmt == LCDFB_FORMAT_RGB_565 ||
-	    info[sel].lcd_pixel_fmt == LCDFB_FORMAT_BGR_565) {
+	if (info.lcd_pixel_fmt == LCDFB_FORMAT_RGB_565 ||
+	    info.lcd_pixel_fmt == LCDFB_FORMAT_BGR_565) {
 		sunxi_lcd_para_write(sel, 0x65);
-		if (info[sel].lcd_pixel_fmt == LCDFB_FORMAT_RGB_565)
+		if (info.lcd_pixel_fmt == LCDFB_FORMAT_RGB_565)
 			rotate &= 0xf7;
 		else
 			rotate |= 0x08;
-	} else if (info[sel].lcd_pixel_fmt < LCDFB_FORMAT_RGB_888) {
+	} else if (info.lcd_pixel_fmt < LCDFB_FORMAT_RGB_888) {
 		sunxi_lcd_para_write(sel, 0x66);
-		if (info[sel].lcd_pixel_fmt == LCDFB_FORMAT_BGRA_8888 ||
-		    info[sel].lcd_pixel_fmt == LCDFB_FORMAT_BGRX_8888 ||
-		    info[sel].lcd_pixel_fmt == LCDFB_FORMAT_ABGR_8888 ||
-		    info[sel].lcd_pixel_fmt == LCDFB_FORMAT_XBGR_8888) {
+		if (info.lcd_pixel_fmt == LCDFB_FORMAT_BGRA_8888 ||
+		    info.lcd_pixel_fmt == LCDFB_FORMAT_BGRX_8888 ||
+		    info.lcd_pixel_fmt == LCDFB_FORMAT_ABGR_8888 ||
+		    info.lcd_pixel_fmt == LCDFB_FORMAT_XBGR_8888) {
 			rotate |= 0x08;
 		}
 	} else {
 		sunxi_lcd_para_write(sel, 0x66);
 	}
 
-	if (info[sel].lcd_if == LCD_FB_IF_SPI) {
+	if (info.lcd_if == LCD_FB_IF_SPI) {
 		sunxi_lcd_cmd_write(sel, 0xb0);
 		sunxi_lcd_para_write(sel, 0x03);
 		sunxi_lcd_para_write(sel, 0xc8); /* Little endian */
 	}
 
-	sunxi_lcd_cmd_write(sel, 0x36); /* Memory sunxi_lcd_para_write Access Control */
+	sunxi_lcd_cmd_write(
+		sel, 0x36); /* Memory sunxi_lcd_para_write Access Control */
 	sunxi_lcd_para_write(sel, rotate);
 
-	address(sel, 0, 0, info[sel].lcd_x - 1, info[sel].lcd_y - 1);
+	address(sel, 0, 0, info.lcd_x - 1, info.lcd_y - 1);
 
 	sunxi_lcd_cmd_write(sel, 0x11);
 	sunxi_lcd_delay_ms(120);
 	sunxi_lcd_cmd_write(sel, 0x29);
 	sunxi_lcd_cmd_write(sel, 0x2c); /* Display ON */
-
 }
 
 static void LCD_panel_exit(unsigned int sel)
@@ -248,7 +245,6 @@ static void LCD_panel_exit(unsigned int sel)
 	sunxi_lcd_delay_ms(10);
 
 	sunxi_lcd_pin_cfg(sel, 0);
-
 }
 
 static int lcd_blank(unsigned int sel, unsigned int en)
@@ -261,16 +257,15 @@ static int lcd_blank(unsigned int sel, unsigned int en)
 	return 0;
 }
 
-
 static s32 LCD_open_flow(u32 sel)
 {
-	lcd_fb_here;
+	LCDFB_HERE;
 	/* open lcd power, and delay 50ms */
 	LCD_OPEN_FUNC(sel, LCD_power_on, 50);
 	/* open lcd power, than delay 200ms */
 	LCD_OPEN_FUNC(sel, LCD_panel_init, 20);
 
-	LCD_OPEN_FUNC(sel, lcd_fb_black_screen, 50);
+	LCD_OPEN_FUNC(sel, sunxi_lcd_fb_black_screen, 50);
 	/* open lcd backlight, and delay 0ms */
 	LCD_OPEN_FUNC(sel, LCD_bl_open, 0);
 
@@ -279,7 +274,7 @@ static s32 LCD_open_flow(u32 sel)
 
 static s32 LCD_close_flow(u32 sel)
 {
-	lcd_fb_here;
+	LCDFB_HERE;
 	/* close lcd backlight, and delay 0ms */
 	LCD_CLOSE_FUNC(sel, LCD_bl_close, 50);
 	/* open lcd power, than delay 200ms */
@@ -293,7 +288,7 @@ static s32 LCD_close_flow(u32 sel)
 static void LCD_power_on(u32 sel)
 {
 	/* config lcd_power pin to open lcd power0 */
-	lcd_fb_here;
+	LCDFB_HERE;
 	power_en(sel, 1);
 
 	sunxi_lcd_power_enable(sel, 0);
@@ -308,7 +303,7 @@ static void LCD_power_on(u32 sel)
 
 static void LCD_power_off(u32 sel)
 {
-	lcd_fb_here;
+	LCDFB_HERE;
 	/* config lcd_power pin to close lcd power0 */
 	sunxi_lcd_power_disable(sel, 0);
 	power_en(sel, 0);
@@ -319,7 +314,7 @@ static void LCD_bl_open(u32 sel)
 	sunxi_lcd_pwm_enable(sel);
 	/* config lcd_bl_en pin to open lcd backlight */
 	sunxi_lcd_backlight_enable(sel);
-	lcd_fb_here;
+	LCDFB_HERE;
 }
 
 static void LCD_bl_close(u32 sel)
@@ -327,14 +322,13 @@ static void LCD_bl_close(u32 sel)
 	/* config lcd_bl_en pin to close lcd backlight */
 	sunxi_lcd_backlight_disable(sel);
 	sunxi_lcd_pwm_disable(sel);
-	lcd_fb_here;
+	LCDFB_HERE;
 }
 
-
 /* sel: 0:lcd0; 1:lcd1 */
 static s32 LCD_user_defined_func(u32 sel, u32 para1, u32 para2, u32 para3)
 {
-	lcd_fb_here;
+	LCDFB_HERE;
 	return 0;
 }
 
@@ -343,7 +337,8 @@ static int lcd_set_var(unsigned int sel, struct fb_info *p_info)
 	return 0;
 }
 
-static int lcd_set_addr_win(unsigned int sel, int x, int y, int width, int height)
+static int lcd_set_addr_win(unsigned int sel, int x, int y, int width,
+			    int height)
 {
 	address(sel, x, y, width, height);
 	sunxi_lcd_cmd_write(sel, 0x2c);
@@ -360,5 +355,5 @@ struct __lcd_panel nv3029s_panel = {
 		.blank = lcd_blank,
 		.set_var = lcd_set_var,
 		.set_addr_win = lcd_set_addr_win,
-		},
+	},
 };
diff --git a/drivers/video/sunxi/lcd_fb/panels/nv3029s.h b/drivers/video/sunxi/lcd_fb/panels/nv3029s.h
index 6214cf4c8..428f00418 100644
--- a/drivers/video/sunxi/lcd_fb/panels/nv3029s.h
+++ b/drivers/video/sunxi/lcd_fb/panels/nv3029s.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
diff --git a/drivers/video/sunxi/lcd_fb/panels/panels.c b/drivers/video/sunxi/lcd_fb/panels/panels.c
index 36e84ed22..03f7da0a4 100644
--- a/drivers/video/sunxi/lcd_fb/panels/panels.c
+++ b/drivers/video/sunxi/lcd_fb/panels/panels.c
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Allwinner SoCs display driver.
@@ -12,39 +12,32 @@
 
 #include "panels.h"
 
-struct sunxi_lcd_drv g_lcd_drv;
+struct sunxi_lcd_drv g_lcd_fb_drv;
 
-struct __lcd_panel *panel_array[] = {
-#ifdef CONFIG_LCD_SUPPORT_KLD35512
+struct __lcd_panel *g_lcd_fb_panel_array[] = {
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_KLD35512)
 	&kld35512_panel,
 #endif
-#ifdef CONFIG_LCD_SUPPORT_KLD39501
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_KLD39501)
 	&kld39501_panel,
 #endif
-#ifdef CONFIG_LCD_SUPPORT_KLD2844B
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_KLD2844B)
 	&kld2844b_panel,
 #endif
 
-#ifdef CONFIG_LCD_SUPPORT_NV3029S
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_NV3029S)
 	&nv3029s_panel,
 #endif
 	NULL,
 };
 
-static void lcd_set_panel_funs(void)
+int sunxi_lcd_fb_lcd_panel_init(void)
 {
 	int i;
-
-	for (i = 0; panel_array[i] != NULL; i++) {
-		sunxi_lcd_set_panel_funs(panel_array[i]->name,
-					 &panel_array[i]->func);
+	sunxi_lcd_fb_disp_get_source_ops(&g_lcd_fb_drv.src_ops);
+	for (i = 0; g_lcd_fb_panel_array[i] != NULL; i++) {
+		sunxi_lcd_set_panel_funs(g_lcd_fb_panel_array[i]->name,
+					 &g_lcd_fb_panel_array[i]->func);
 	}
-}
-
-int lcd_init(void)
-{
-	sunxi_disp_get_source_ops(&g_lcd_drv.src_ops);
-	lcd_set_panel_funs();
-
 	return 0;
 }
diff --git a/drivers/video/sunxi/lcd_fb/panels/panels.h b/drivers/video/sunxi/lcd_fb/panels/panels.h
index bf4324c40..5279ec640 100644
--- a/drivers/video/sunxi/lcd_fb/panels/panels.h
+++ b/drivers/video/sunxi/lcd_fb/panels/panels.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Allwinner SoCs display driver.
@@ -12,6 +12,7 @@
 
 #ifndef __PANEL_H__
 #define __PANEL_H__
+
 #include "../include.h"
 #include "lcd_source.h"
 #include "../disp_display.h"
@@ -19,32 +20,30 @@
 
 struct __lcd_panel {
 	char name[32];
-	struct disp_lcd_panel_fun func;
+	struct sunxi_lcd_fb_disp_lcd_panel_fun func;
 };
 
-extern struct __lcd_panel *panel_array[];
+extern struct __lcd_panel *g_lcd_fb_panel_array[];
 
-struct sunxi_lcd_drv {
-	struct sunxi_disp_source_ops src_ops;
-};
+extern int
+sunxi_lcd_fb_disp_get_source_ops(struct sunxi_lcd_fb_disp_source_ops *src_ops);
 
-extern int sunxi_disp_get_source_ops(struct sunxi_disp_source_ops *src_ops);
-int lcd_init(void);
-#ifdef CONFIG_LCD_SUPPORT_KLD35512
+int sunxi_lcd_fb_lcd_panel_init(void);
+
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_KLD35512)
 extern struct __lcd_panel kld35512_panel;
 #endif
 
-#ifdef CONFIG_LCD_SUPPORT_KLD39501
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_KLD39501)
 extern struct __lcd_panel kld39501_panel;
 #endif
 
-#ifdef CONFIG_LCD_SUPPORT_KLD2844B
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_KLD2844B)
 extern struct __lcd_panel kld2844b_panel;
 #endif
 
-#ifdef CONFIG_LCD_SUPPORT_NV3029S
+#if IS_ENABLED(CONFIG_LCD_SUPPORT_NV3029S)
 extern struct __lcd_panel nv3029s_panel;
 #endif
 
-
 #endif
diff --git a/drivers/video/sunxi/lcd_fb/panels/spi_panel.c b/drivers/video/sunxi/lcd_fb/panels/spi_panel.c
new file mode 100644
index 000000000..4c85ef4b9
--- /dev/null
+++ b/drivers/video/sunxi/lcd_fb/panels/spi_panel.c
@@ -0,0 +1,78 @@
+// SPDX-License-Identifier: GPL-2.0-or-later
+/* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
+/*
+* Allwinner SoCs display driver.
+*
+* Copyright (C) 2016 Allwinner.
+*
+* This file is licensed under the terms of the GNU General Public
+* License version 2.  This program is licensed "as is" without any
+* warranty of any kind, whether express or implied.
+*/
+
+#include "../include.h"
+
+#define SPIDEV_MODULE_NAME "lcd_fb_panel_device"
+
+static int spi_dev_probe(struct spi_device *spi)
+{
+	LCDFB_HERE;
+	return 0;
+}
+
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(6, 1, 0))
+static void spi_dev_remove(struct spi_device *spi)
+#else
+static int spi_dev_remove(struct spi_device *spi)
+#endif
+{
+	LCDFB_HERE;
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(6, 1, 0))
+	return;
+#else
+	return 0;
+#endif
+}
+
+static const struct of_device_id spidev_match[] = {
+	{
+		.compatible = "allwinner,spi-panel",
+	},
+	{},
+};
+
+static struct spi_driver spidev_driver = {
+	.probe = spi_dev_probe,
+	.remove = spi_dev_remove,
+	.driver = {
+		.owner = THIS_MODULE,
+		.name = SPIDEV_MODULE_NAME,
+		.of_match_table = spidev_match,
+	},
+};
+
+static int __init spi_panel_init(void)
+{
+	int ret;
+
+	ret = spi_register_driver(&spidev_driver);
+	if (ret) {
+		LCDFB_WRN("spi panel register driver failed!\n");
+		return ret;
+	}
+
+	return ret;
+}
+
+static void __exit spi_panel_exit(void)
+{
+	spi_unregister_driver(&spidev_driver);
+}
+
+module_init(spi_panel_init);
+module_exit(spi_panel_exit);
+
+MODULE_AUTHOR("zhangyuanjing <zhangyuanjing@allwinnertech.com>");
+MODULE_LICENSE("GPL");
+MODULE_VERSION("1.0.0");
+MODULE_DESCRIPTION("Register SPI Panel device for Allwinner LCD FB");
-- 
2.25.1

